=== cmake/tribits/examples/TribitsExampleProject2/packages/package1/CMakeLists.txt ===
tribits_package(Package1)
add_subdirectory(src)
tribits_add_test_directories(test)
tribits_package_postprocess()
